#ifndef __HAIR_H__
#define __HAIR_H__

#include <string>
#include <vector>
//
//#ifdef SINGLE_PRECISION
//typedef float Float;
//#else
//typedef double Float;
//#endif
typedef float Float;

typedef struct Point2 {
	Float x, y;
} Point2;

typedef struct Point3 {
	Float x, y, z;
} Point3;

typedef struct Hair {
	std::vector<Point3> vertices;
	std::vector<bool> vertexStartsFiber;
	std::vector<Point2> verticesTexCoord;
	unsigned int hairCount;
} Hair;

typedef struct Clump {
	Float clumpRadius;
	Point2 texBoundU, texBoundV;
} Clump;

// Hair IO
bool importHair(const std::string &path, Hair& hair);
bool exportHairBinary(const std::string &path, const Hair &hair);
bool exportHairText(const std::string &path, const Hair &hair);
// Clump info IO
bool exportInfo(std::string path, const std::vector<Clump> &clumpInfo);
#endif